;;; "kibologize.el" (GNU EMACS LISP)
;;; Kibology program, based on "flame.el" by Ian G. Batten & others
;;; Generates ravings about Kibology, in the style of Kibo.
;;; "M-x load-file" it into Gnu Emacs and do "M-x kibologize"...
;;; or, for serious sillyness, load-file it and "M-x psychoanalyze-kibo".

;;; Original sections are Copyright James "Kibo" Parry.    
;;; Release 1.6  1/8/90
;;; Please send bug reports, comments, compliments, and bombs to:
;;; kibo%pawl.rpi.edu@itsgw.rpi.edu or userfe0n@rpitsmts.bitnet

;;; someday I'll fix the way the quote marks make it crash 
;;; ("When Kibo says '_____', he means '______'")

(random t)

;;; top level -- framework of sentences to be made
(defvar x-sentence
  '(
    ((x-query))
    ((x-judgment))
    (There\'s one reason for (x-thing) \, and it\'s (x-fund-force) \.)
    (Reach out with your (x-soul) and (x-sense) the (x-fund-force) \.)
    ((x-fund-force) is like (x-a-symbol) \.)
    ((x-sense) Kibology\, and (x-good-verb) \!)
    (Why not (x-good-verb) \?)
    (You can (x-sense) when you try to (x-sense) \.)
    (Can you (x-sense) (x-fund-force) \?)
    ((x-thing) is (x-what-it-is) \.)
    ((x-person-be) (x-what-it-is) \, because (x-reason) \.)
    ((x-thing) makes sense \.)
    ((x-thing-s) not (x-thing-things) \.)
    ((x-thing-s) the (x-something-of) of (x-thing-things) \.)
    ((x-thing) seems (x-adj) to me \!)
    (Enjoy (x-thing-things) \!)
    (When (x-person) says \' (x-sentence) \'\, it means \' (x-sentence) \'\.)
    ((x-thing-things) can teach us how to (x-i-verb) \.)
    ((x-adj) (x-things) are (x-adj) \.)
    (Do you want to (x-t-verb) (x-thing-things) \? You\'re allowed\! )
    ((x-quote))
    ((x-thing) is not (x-what-it-is) \, I (x-sense) \!)
    (If (x-thing-things) could (x-i-verb) \, would the Universe\, U
       for (x-U-word) \, be (x-adj) \?)
    ((x-person-y) could (x-t-verb) (x-person) \.)
    ((x-dir) with (x-thing-things) \!)
    (If you (x-ability) (x-t-verb-sense) the (x-something-of) of (x-thing)
       \, (x-result) \.)
    ((x-you-we-they) (x-ability) (x-t-i-verb) \.)
    (Let\'s (x-t-i-verb) \!)
    ((x-person-be) (x-adj) \.)
    (I think (x-person-be) (x-adj) (x-ratio) of the time\.)
    ((x-ratio) of the (x-adj) (x-thing-s) (x-adj) \.)
    ((x-sentence) (x-agree))
    ((x-sentence) (x-agree))
   ))
(defvar x-sentence-loop (nconc x-sentence x-sentence))

;;; "Variety is the ____ of life."
(defvar x-something-of
  '(
    (point) (meaning) (goal) (strategy) (cost) (birth)
    (genesis) (purpose) (beginning) (end) (color) (shape)
    (stupidity) (friend) (kind) (enemy) (guru) (definition)
    (slave) (reward) (symbol) (foolishness) (explosion) (Oracle)
    (answer to the question) (core) (mission) (greatness)
    (code of honor) (full range) (power) (meaning) (refuge) (hiding place)
    (sameness) (silliness) (priviledge) (form) (renaissance) (use)
    (best) (dance) (opiate) (opposite) (luxury) (god) (creation) (death)
    (business) (book) (whole mess) (evil twin) (incredible truth)
    (price) (spice) (bane) (reward) (energy) (destiny) (joy)
  ))
(defvar x-something-of-loop (nconc x-something-of x-something-of))

;;; "The ____ of life are silly."
(defvar x-somethings-of
  '(
    (options) (definitions) (creators) (friends)
    (enemies) (kinds) (destinies) (rebirths) (uses) (forms) (feelings)
    (capacities) (freedoms) ((x-something-of) and (x-something-of))
    (isms) (chapters of the book) (highlights and lowlights)
    (miracles) (deities) (shapelessnesses) ((x-adj) parts)
    (powers) (uses) (sounds) (answers to the questions)
    (energies) (last gasps) (flavors) (differences) (rewards)
  ))
(defvar x-somethings-of-loop (nconc x-somethings-of x-somethings-of))

;;; "Everything is made of ____."  "____ is power!"
(defvar x-fund-force
  '(
    (vril) (the total of all forms of vril) (the sum of all forms of odyle)
    (vrilforce) (odyleforce) (vrilmatter) (odylematter) (odyle)
    (odylethought) (vrilthought) (goodness) (ubiquitons) (memory)
    (vril and odyle) (television) (reality) (the shape of (x-fund-force))
    (mindwaves) (the Earth) ((x-poss) fate) ((x-poss) destiny)
    ((x-poss) life) (the ecology)  (light) (energy)
    (the Universe\, U for (x-U-word) \,) (life) (space)
    (the Void) (new ideas) (everything) (gravity) (light) (sound)
    (deadly radiation that comes out of TV sets)
    ((x-poss) ability to (x-sense))
    ((x-poss) (x-thing)) ((x-a-symbol))
    (atoms) (mind control rays) (deities) (people like you and me)
    (brainwaves) (the excitement) (our souls) (thought)
  ))
(defvar x-fund-force-loop (nconc x-fund-force x-fund-force))

;;; some mystical body part, maybe non-physical
(defvar x-soul
  '(
    (soul) (aura) (mind) (thought-loop) (meat) (body) (fingers)
    (sixth sense) (faith) (brain) (understanding of peoples\' minds)
    (doubts) (powers\, if any\,) (inner mind) (outer mind) (essence)
    (life-force) (vibrations) (creative \'insanity\')
    (senses) (eyes) (feelings) (intellect) (intuition) (brain)
  ))
(defvar x-soul-loop (nconc x-soul x-soul))

;;; "____ the excitement."  "I can ____!"
(defvar x-sense
  '(
    (catch) (feel) (experience) (touch) (see) (witness) (feel)
    (smell) (watch) (contact) (get in touch with) (consume) (know)
    (KNOW) (believe) (reach) (walk into) (fall in love with)
    (see with your inner eye) (open a mental door)
    (be consumed by) (engulf) (join) (hear) (listen to) (remember)
    (sense) (trust) (doubt) (ignore) (think about) (understand)
  ))
(defvar x-sense-loop (nconc x-sense x-sense))

;;; "Universe" is always followed by "U for ____"....
(defvar x-U-word
  '(
    (Useless) (Ultimate) (Unique) (Ugly) (Ubiquitous) (Uncle)
    (Uneven) (Uncensored) (Ulterior) (Uranium) (Universe)
    (Utter) (\'Ugh\!\') (Underwhelming) (Underhanded) (Ullage)
    (Umbilical) (Unaccompanied) (Unbalanced) (Unbiased) (Unbounded)
    (Uncanny) (Uncertain) (Undying) (Undeserved) (Unfair) (Uniform)
    (Unessential) (Unmentionable) (Unnatural) (Un) (Unisex)
    (Upsetting) (Urgent) (Urban) (Useful) (Utopia) (You)
    (Uncreated) (Umanity) (Universe) (U and Me) (Up and Up and Up)
  ))
(defvar x-U-word-loop (nconc x-U-word x-U-word))

;;; Any singular noun.  "____ is my middle name." "A red ____ is in my sock."
(defvar x-thing
  '(
    (sex) (the future) (Kibology) (allowedness) (Kibo) (death)
    (the truth) (life) (birth) (Chinese food) (plastic) (food)
    (the sacred symbol \'298R\') (Kibology) (Nature) (reality)
    (the script we\'re following in THIS life)
    (conflict between (x-thing-things) and (x-thing))
    (something like (x-a-symbol))
    (the truth about (x-fund-force))
    (the fact that (x-thing-s) (x-adj))
    (allowedness) (fire) (clothing) (reality) (fiction)
    (another dimension) (vril) (communication) (relaxation)
    (the Universe \, U for (x-U-word) \,) (radiation) (humanity)
    (a game) (a guess) (the reason why) (existence) (the Void)
    (zumfing) (what they call insanity) (television) (religion)
    ((x-poss) body) (love) (nothing) (everything) (zumfing)
    (an egg) (one solitary atom) (the Bible) (the Kibo Bible)
    (Kibology) (Kibo) (being allowed) (the word \'Noom\')
    (spark of life) ((x-thing) in a box) (language)
    (the color blue)
  ))
(defvar x-thing-loop (nconc x-thing x-thing))

;;; some intransitive infinitive verb that's really neat-o
(defvar x-good-verb
  '(
    (grow) (live) (own a home) (be someone) (live to the fullest)
    (stay sane) (be allowed) (understand everything) (be allowed)
    (conserve energy) (zumf) (love) (eat well) (eat Chinese food)
    (allow people to be people) (learn about (x-thing-things))
    (help Harry) (profit) (move into a new dimension)
  ))
(defvar x-good-verb-loop (nconc x-good-verb x-good-verb))

;;; "X is ____."
(defvar x-what-it-is
  '(
    (real) (nothing) (everything) (life itself) (something) (a bozo)
    (silly) (complex) (serious) (incomprehensible) (simple)
    (what it appears) ((x-adj)) (a bozo) (ALLOWED) (revered)
    (worth (x-poss) time) (surreal) ((x-adj)) (a sham) (the Truth)
    (like a spider\'s web) (unreal) (Kibology) (allowed)
    (here) (everywhere) (perverse) (allowed) (false)
  ))
(defvar x-what-it-is-loop (nconc x-what-it-is x-what-it-is))

;;; name of a person... "____ is a bozo."
(defvar x-person
  '((Kibo) (Kibo) (Kibo) (Kibo) (Kibo) (someone) (some weenie)
    (a false god) (God) (Jesus) (Confucius) (Aristotle) (Einstein)
    (the President) (the Pope) (Kibo\'s best friend) (your pal)
    (Harry\, who was helped by Kibology\,) (a Kibologist)
    (Xibo) (Xibo) (Xibo) (Kibo) (Kibo) (the evil Xibo)
    (some bozo) (Freud) (Albert Einstein) (Kibo)
    (Kibo\, the great teacher) (anyone who is allowed)))
(defvar x-person-loop (nconc x-person x-person))

;;; like x-person but includes "you", "I"
(defvar x-person-y
  '(
    ((x-person)) ((x-person)) ((x-person)) (you) (I) (everyone)
    (you) (I) (I) (you) ((x-person))
  ))
(defvar x-person-y-loop (nconc x-person-y x-person-y))

;;; person plus "to be"... "____ a bozo."
(defvar x-person-be
  '(
    ((x-person) is) ((x-person) is not) (I have been)
    ((x-person) was) ((x-person) will never be)
    (Harry\, before he was helped by Kibology\, was)
    (you are) (I am) ((x-you-we-they) all are) (you aren\'t)
    (people are) (humanity is) (I used to be) (I shall be)
    (you will always be) (you\'re) (you once were)
    (Kibo says you\'re allowed to be)
    (Xibo says you\'re not allowed to be)
    (everyone was\, is\, and always will be) (nobody is)
    (I was) (I can be\, when I want to\,) (you are allowed to be)
    (Einstein would be\, if he were alive\,) ((x-you-we-they) are)
    (I\'m NOT) (you are not) (we should be) (they\'re)
  ))
(defvar x-person-be-loop (nconc x-person-be x-person-be))

;;; "You", "We", or "They", so that "are" can follow
(defvar x-you-we-they
  '(
    (you) (we) (they) (people)
    (you) (we) (you) (they)
    (you) ((x-adj) people)
  ))
(defvar x-you-we-they-loop (nconc x-you-we-they x-you-we-they))

;;; a reason... "Kibo likes plastic because ____."
(defvar x-reason
  '(
    (it is allowed) (everything\'s allowed) (life is fair)
    (that\'s how the Universe\, U for (x-U-word) \, works)
    (there really is no other way to do it) (it\'s natural)
    (it\'s less painful than death)
    (reality is somewhat flexible) (life is serious)
    (that seems to be the best way)
    (we can change the future) (life cheats)
    (sometimes life\'s dice come up with your number)
    ((x-fund-force) is like (x-a-symbol))
    (it\'s the natural way of things)
    (that\'s the way it HAS to be)
    (it makes sense) (it\'s more fun that way)
  ))
(defvar x-reason-loop (nconc x-reason x-reason))

;;; plural or collective noun... "____ are blue."  "Kibo eats red _____."
(defvar x-things
  '((emotions) (feelings) ((x-poss) thoughts) (atoms) (nodes) (words)
    (languages) (pets) (books) (writings of Kibo) (flowers)
    (sharp knives) (many (x-things)) (multiple realities)
    (colors) (destinies) (victories) (many worlds)
    (different meanings) (what I say and what you hear) 
    (lies) ((x-poss) abilities) (Chinese restaurants)
    (all nations everywhere) (things that matter to us all)
    (all the (x-things) in the Universe\, U for (x-U-word) \,)
    (unspoiled places) (works of art) (past\, present\, and future)
    ((x-poss) toys) (sane ideas for today\'s lifestyle)
    (bunches of (x-things)) (vril and odyle)
    (holes in (x-poss) knowledge) (computers) (people) (bozos)))
(defvar x-things-loop (nconc x-things x-things))

;;; singular OR plural noun...
(defvar x-thing-things
  '(((x-thing)) ((x-things)) ((x-thing)) ((x-things))
    ((x-thing)) ((x-things)) ((x-thing)) ((x-thing))
    ((x-thing-things) and (x-thing-things))))
(defvar x-thing-things-loop (nconc x-thing-things x-thing-things))

;;; subject plus "to be"... "_______ my middle name."
(defvar x-thing-s
  '(
    ((x-thing) is)
    ((x-things) are)
    ((x-thing) is)
    ((x-things) are)
    ((x-thing) is)
    ((x-thing) and (x-thing) are)
   ))
(defvar x-thing-s-loop (nconc x-thing-s x-thing-s))

;;; ordinary intrans. verbal infinitive... "I like to ____."
(defvar x-i-verb
  '(
    (eat) (be) (exist) (grow) (breathe) (have an experience)
    ((x-sense)) (be me) (keep going to (x-poss) limit)
    (warm up to (x-t-i-verb)) (try to (x-t-i-verb))
    (go) (shine) (radiate) (explode in fireworks)
    (work) (disappear) (be) (stay in our world) (create)
    (think) (zumf) (stay) (live) ((x-good-verb)) (die)
  ))
(defvar x-i-verb-loop (nconc x-i-verb x-i-verb))

;;; ordinary transitive verbal infinitive... "I like to ____ rats."
(defvar x-t-verb
  '(
    (see) (talk to) (kill) (teach Kibology to) (love) (destroy)
    ((x-sense)) (allow all) (be) (support the ideas of)
    (challenge) (create) (learn from) (avoid) (accept)
    (love) (think about) (be inspired by) (share)
    (fix up) (fiddle with) (tamper with) (change) (preserve)
    (resemble) (seem related to) (wrap up)
   ))
(defvar x-t-verb-loop (nconc x-t-verb x-t-verb))

;;; possessive adjective... "This is ____ life!"
(defvar x-poss
  '((my) (your) (Kibo\'s) (Kibo\'s) (our) (everybody\'s) (our)
    (nobody\'s) (anybody\'s) (Xibo\'s) (Kibo\'s) (our) (your)
    (Kibo\'s) (my) (a) (some)
    (your) (your) (your life\'s) (a human being\'s) (our) (George\'s)
    (Harry\'s) (somebody\'s) (everyone\'s) (my) (your) (Kibo\'s)
    (God\'s) (Einstein\'s) (my) (my) (your) (your) (Kibo\'s)))
(defvar x-poss-loop (nconc x-poss x-poss))

;;; an adjective... "The ____ fox jumps..."
(defvar x-adj
  '(
    (new) (old) (young) (nice) (bad) (silly) (good) (great) (mock) (good)
    (dark) (sensitive) (bright) (serious) (eternal) (nonexistant) (great)
    (pure) (contaminated) (untainted) (un- (x-adj)) ((x-ratio) (x-adj))
    (hefty) (wimpy) (standard) (stuck-in-a-rut) (sad) (happy) (newly created)
    (half-baked) (well-worn) (right) (wrong) (fair) (unfair) (incredible)
    (very very (x-adj)) (halcyon) (beautiful) (evil) (Xibotic) (Kibotic)
    (bogus) (darned) (interestingly (x-adj)) (anti- (x-adj)) (sane)
    ((x-adj) (x-adj)) (thing-loving) (galactic) (infinite) (silly) (truthful)
    (artistic) (spurious) (modern) (true) (false) (futuristic)
    (warped) (intense) (Kibological) (baby) (respected) (boring)
    (confusing) (obvious) (ubiquitous) (very (x-adj)) (sacred)
  ))
(defvar x-adj-loop (nconc x-adj x-adj))

;;; a complete sentence that shows up rarely
(defvar x-quote
  '(
    (La\!)
    (You\'re allowed\!)
    (All (x-things) are arbitrary\!)
    (Kibology is no joke\.)
    (Kibology is deadly serious\.)
    (Zumf and be perfect\!)
    (Be allowed\!)
    (La\, la\, la\.\.\.)
    (Do everything\!)
    (Xibology is no fun\.)
    (You\'re allowed to not be a Kibologist if you want\.)
    (Kibology helped Harry\!)
    (George was helped by Kibology\.  Allow yourself to be helped too\!)
    (Hmm\.\.\.)
    ((x-sentence) WHY\?)
    (Whee\!)
    (La\.\.\.)
    (You are ALLOWED\.)
    (Yes\!)
    (Yes\.\.\. (x-sentence))
    (You\'re allowed\.\.\.)
    ((x-fund-force) abounds \!)
    (Be (x-adj) \!)
    (Always\, always\, please remember\.\.\. (x-sentence))
  ))
(defvar x-quote-loop (nconc x-quote x-quote))

;;; direction for "____ with nuclear weapons!"
(defvar x-dir
  '((up) (down) (in) (out) (stick) (up) (down) (make life fun)
    (try it) (live) (life is a game) (good luck)
   ))
(defvar x-dir-loop (nconc x-dir x-dir))

;;; some transitive verb or sense
(defvar x-t-verb-sense
  '(((x-t-verb)) ((x-sense))))
(defvar x-t-verb-sense-loop (nconc x-t-verb-sense x-t-verb-sense))

;;; Can, can't, etc... "You ____ burn water."
;;; note that this should go with "You" or "We" or "They" since it may use "are"
(defvar x-ability
  '((can) (can\'t) (often can) (might) (want to) (never) (have to)
    (are allowed to) (can teach others to) (are allowed not to)
    (should) (should not) (try to) (can try to) (are afraid to)
    (are not afraid to) (can) (cannot) (can not) (can) (can too)
    (have a reason to) (need no excuse to)
    (always) (wish everyone could)))
(defvar x-ability-loop (nconc x-ability x-ability))

;;; "If you can read this, __________."
(defvar x-result
  '(
    (please tell everyone) (don\'t tell anyone) (ssh\! be quiet)
    (you\'ve got it made) (great) (oh no) (you don\'t need help)
    (it\'s because (x-reason)) (you get the idea)
    (keep trying) (it\'s nice to get it over with) (sorry about that)
    (enjoy (x-thing-things)) (whee) (DO IT) (don\'t put it off)
    (say what you feel) (allow yourself) (you\'re allowed) (allow it to happen)
    (you win) (you lose) ((x-person) wins) (you have won)
    (it\'s a sign) (go ahead) (that\'s allowed) (relax)
    (you (x-ability) (x-good-verb))
  ))
(defvar x-result-loop (nconc x-result x-result))

;;; "I'm silly ____ of the time." "____ of the cat is black."
(defvar x-ratio
  '((some) (all) (none) (most) (little) (one hundred percent)
    (ABSOLUTELY (x-ratio)) (all) (every bit) (none) (three-quarters)
    (half of all) (part) (all) (none) (exactly half) (the best part)
    (half) (much) (very little) (almost all) (only a small fraction)))
(defvar x-ratio-loop (nconc x-ratio x-ratio))

;;; "Your heart is ____." optional "a/an" plus something symbolic.
(defvar x-a-symbol
  '(
    (a suit of armor) (a wild animal) (an ocean) (a galaxy)
    (a dark place where nobody has sung) (the symbol \'298R\')
    (a big box full of (x-things)) (an apple) (an apple with a worm in it)
    (a fresh warm bag of newly-roasted peanuts at the circus)
    (a Chinese Restaurant with bilingual menus) (sex)
    (the dying words of Einstein) (a lightning bolt)
    (a heavy brick) (a bathtub full of telephones)
    (a stack of blocks that people kept adding to until (x-person-y)
       knocked it down)
    (a forty-five degree angle to reality)
    (the inside of a microwave oven) (the color cobalt blue) 
    (the color ultramarine blue) (the color sky blue)
    (a bowl of lime Jello) (skywriting) (a short skyscraper)
    (a bunch of bozos who know that they are bozos)
    (a big city with no people but many (x-things))
    (the center of the Universe\, U for (x-U-word) \,)
    (a private tomb with a view) (a hot refrigerator) (Einstein\'s brain)
    (a sock which is comfortable even though it has a BIG hole in the toe)
    (a locked restroom in a Chinese restaurant) (the letter K)
    (last week\'s news) (a dry\, dead cactus) (a new life-form)
    (a spiderweb) (a summit on a high mountain) (a vortex)
    (the songs that food sings when it cooks) (a beacon)
    (the speed of Light) (the failure of Gravity itself to hold things down)
  ))
(defvar x-a-symbol-loop (nconc x-a-symbol x-a-symbol))

;;; any complete questioning sentence.
(defvar x-query
  '(
    (What\'s the (x-something-of) of (x-fund-force) \?)
    (What are the (x-somethings-of) of (x-fund-force) \?)
    (I'd like to know the (x-something-of) of (x-fund-force) \,
       because (x-reason) \.)
    (Who is (x-person) \?)
    (Can (x-person-y) (x-t-i-verb) \?)
    (Why does (x-thing) (x-t-i-verb) \?)
    (How do (x-things) (x-t-i-verb) \?)
    (Does (x-thing) (x-t-i-verb) \? (x-agree))
  ))
(defvar x-query-loop (nconc x-query x-query))

;;; a simple cry of "Yes!" "No!" etc. to be added after some sentences
(defvar x-agree
  '(
    (Yes\!)
    (YES\!)
    (TRUE\!)
    (FALSE\!)
    (Not true\.)
    (True or False\?  You be the judge\!)
    (YES\!\!\!)
    (No\.)
    (NO\!)
    (Maybe\.\.\.)
    (Could be\.)
    (YES\!\!\!)
    (Yes\.\.\.)
    (No\, but (x-sentence))
    (Yes\, and also\, (x-sentence))
    ((x-ratio) true\!)
    (Believe it or not\!)
  ))
(defvar x-agree-loop (nconc x-agree x-agree))

;;; a statement of opinion about something.
(defvar x-judgment
  '(
    ((x-thing) abounds \!)
    ((x-things) abound \!)
    ((x-thing) is evil and should be destroyed \!)
    ((x-things) are evil and should be destroyed \!)
    ((x-judgment) Believe it or not\!)
  ))
(defvar x-judgment-loop (nconc x-judgment x-judgment))

;;; any predicate.  "I like to ____".  Biased towards intransitives.
(defvar x-t-i-verb
  '(
    ((x-i-verb)) ((x-t-verb) (x-thing-things))
    ((x-i-verb)) ((x-i-verb)) ((x-i-verb))
    ((x-i-verb)) ((x-t-verb) (x-adj) (x-thing-things))
    ((x-t-verb) (x-thing-things))
  ))
(defvar x-t-i-verb-loop (nconc x-t-i-verb x-t-i-verb))


(defmacro define-element (name)
  (let ((loop-to-use (intern (concat name "-loop"))))
    (` (defun (, (intern name)) nil
      (let ((step-forward (% (random) 10)))
        (if (< step-forward 0) (setq step-forward (- step-forward)))
        (prog1
          (nth step-forward (, loop-to-use))
         (setq (, loop-to-use) 
              (nthcdr (1+ step-forward) (, loop-to-use)))))))))

(define-element "x-sentence")
(define-element "x-something-of")
(define-element "x-somethings-of")
(define-element "x-fund-force")
(define-element "x-soul")
(define-element "x-sense")
(define-element "x-U-word")
(define-element "x-thing")
(define-element "x-good-verb")
(define-element "x-what-it-is")
(define-element "x-person")
(define-element "x-person-y")
(define-element "x-person-be")
(define-element "x-you-we-they")
(define-element "x-reason")
(define-element "x-things")
(define-element "x-thing-things")
(define-element "x-thing-s")
(define-element "x-i-verb")
(define-element "x-t-verb")
(define-element "x-poss")
(define-element "x-adj")
(define-element "x-quote")
(define-element "x-dir")
(define-element "x-t-verb-sense")
(define-element "x-ability")
(define-element "x-result")
(define-element "x-ratio")
(define-element "x-a-symbol")
(define-element "x-query")
(define-element "x-agree")
(define-element "x-judgment")
(define-element "x-t-i-verb")

(defun *kibologize nil
  (kibologize-expand '(x-sentence)))

(defun kibologize-expand (object)
  (cond ((atom object)
   object)
  (t (mapcar 'kibologize-expand (funcall (car object))))))

(defun flatten (list)
  (cond ((atom list)
   (list list))
  (t (apply 'append (mapcar 'flatten list)))))

(defun kibologize (arg)
  "x"
  (interactive "p")
  (let ((w (selected-window)))
    (pop-to-buffer (get-buffer-create "*Kibology*"))
    (goto-char (point-max))
    (insert ?\n)
    (kibologize2 arg)
    (select-window w)))

(defun kibologize2 (arg)
  (let ((start (point)))
    (kibologize1 arg)
    (fill-region-as-paragraph start (point) t)))

(defun kibologize1 (arg)
  (cond ((zerop arg) t)
  (t (insert (concat (sentence-ify (string-ify (append-suffixes-hack
        (flatten (*kibologize)))))))
     (kibologize1 (1- arg)))))

(defun sentence-ify (string)
  (concat (upcase (substring string 0 1))
    (substring string 1 (length string))
    "  "))

(defun string-ify (list)
  (mapconcat
   '(lambda (x)
      (format "%s" x))
   list
   " "))

(defun append-suffixes-hack (list)
  (cond ((null list)
   nil)
  ((memq (nth 1 list)
         '(\? \. \, s\! \! s \'s \-loving))
   (cons (intern (format "%s%s" (nth 0 list) (nth 1 list)))
         (append-suffixes-hack (nthcdr 2 list))))
  (t (cons (nth 0 list)
     (append-suffixes-hack (nthcdr 1 list))))))

(defun psychoanalyze-kibologist ()
  "Kibo goes to the analyst."
  (interactive)
  (doctor)        ; start the psychotherapy
  (message "")
  (switch-to-buffer "*doctor*")
  (sit-for 0)
  (while (not (input-pending-p))
    (kibologize2 (if (= (% (random) 2) 0) 2 1))
    (sit-for 0)
    (doctor-ret-or-read 1)))

